#include <xc.h>
#include <stdio.h>
//#include <stdlib.h>
//#include <stdint.h>
//#include <plib/timers.h>

#define _XTAL_FREQ 16000000

#define TRUE    (1)
#define FALSE   (0)
#define	SALIDA	(0)
#define	ENTRADA	(1)

//Timer0
//Prescaler 1:8; TMR0 Preload = 3036; Actual Interrupt Time : 500 ms

#define UART_Clear_Errors()		\
	if (OERR){			\
		TXEN = FALSE;		\
		TXEN = TRUE;		\
		CREN = FALSE;		\
		CREN = TRUE;		\
	}				\
	if (FERR){			\
		TXEN = FALSE; 		\
		TXEN = TRUE; 		\
		CREN = FALSE; 		\
		CREN = TRUE; 		\
	}                               \

//Place/Copy this part in declaration section

void TestUART(void) {
    char string[] = "[alive]\n";
    int i = 0;

    for (i = 0; string[i] != NULL; i++) { // Send Test
        while (!TXIF);
        TXREG = string[i];
    }
}

void UART_Init(void) {

    SYNC = FALSE; // Modo asynchronous
    SPEN = TRUE; // Habilita puerto serie
    DTRXP = FALSE; // No Invertir polaridad

    // Config Baud Rate - Pg. 192
    ABDOVF = FALSE; // Auto-baud
    BRG16 = FALSE; // Baud Rate Generator 16 bits
    BRGH = FALSE; // Baud Rate Generator High
    SPBRGH = FALSE;
    SPBRG = 25; // 9600 Bauds

    // Recepcion Rx
    TRISB5 = ENTRADA; // RB5 -> RX Entrada
    RX9 = FALSE; // Sin 9no bit de Rx
    SENDB = FALSE; // Break Char
    CREN = TRUE; // Habilita la recepcion continua
    RCIDL = FALSE; // Rx idle flag
    RCIF = FALSE; // Reset Rx pin flag
    //RCIP = TRUE; // Rx High Priority Interrupt
    RCIE = FALSE; // Habilita las interrupciones de Rx

    // Trasmicion Tx
    TRISB7 = SALIDA; // RB7 -> TX Salida
    TX9 = FALSE; // 9no bit de Tx
    CKTXP = FALSE; // Tx idle is HIGH
    TXEN = FALSE; // Purga la Tx
    TXEN = TRUE; // Habilita la Tx
    TXIE = FALSE; // No habilita las interrupciones de Tx

    IPEN = FALSE; // Deshabilita la prioridad de las interrupciones
    PEIE = TRUE; // Habilita interrupciones de Perifericos
    GIE = TRUE; // Habilita interrupciones Globales

    UART_Clear_Errors();
    TestUART(); // [Debug]
}

//Prescaler 1:8; TMR0 Preload = 3036; Actual Interrupt Time : 500 ms

void InitTimer0() {
    T0CON = 0x82; // 1000 0010
    TMR0H = 0x0B; // 0000 1011
    TMR0L = 0xDC; // 1101 1100
    GIE = 1;
    TMR0IE = 1;
}

char rx_in = FALSE;
char rx_input = 0x00;

void interrupt isr(void) {
    // Rx UART
    if (RCIF) {
        RCIF = FALSE; // Reset Rx Flag
        rx_in = TRUE;
        rx_input = RCREG;
    }
    // Timer0
    if (TMR0IF) {
        TMR0IF = 0;

        TMR0H = 0x0B;
        TMR0L = 0xDC;
        //Enter your code here
        LATB = ~LATB;
    }
}

int main(int argc, char** argv) {

    InitTimer0();
    UART_Init();

    while (TRUE) {
        UART_Clear_Errors();

        if (rx_in) {
            rx_in = FALSE; // Reset Rx Flag
            while (!TXIF);
            TXREG = rx_input;
        }
    }

    return (0);
}
